{% extends 'profile/layouts/admin/admin_layout.html' %}

{% load static %}

{% block css %}
    <link rel="stylesheet" type="text/css" href="{% static 'admin/css/datatables/datatables.min.css' %}">

    <style>
        .img-bagss {
            position: absolute;
            top: 0;
            background-color: rgba(255, 0, 0, 0.8);
            text-align: center;
            font-weight: 500;
            line-height: 16px;
            padding: 5px 10px;
            color: #FFFFFF;
            border-radius: 5px 5px 5px 0;
        }
        .img-bagss .tag-bln { font-size: 15px; }
    </style>

{% endblock css %}

{% block navbar %}
    {% include 'profile/layouts/admin/navbar.html' %}
{% endblock navbar %}

{% block main %}
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{% url 'profile:admin_home' %}">Home</a></li>
            <li class="breadcrumb-item active" aria-current="page">Galeri</li>
        </ol>
    </nav>

    {% if messages %}
        {% for message in messages %}
            <div class="alert {{ message.tags }} my-2" role="alert">
                {{message}}
                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>  
        {% endfor %}
    {% endif %}

    <a href="{% url 'profile:admin_gallery_create' %}"> 
        <button type="button" class="btn btn-info mt-2 mb-4"><i class="bi bi-plus"></i> Tambah Galeri</button>
    </a>

    <div class="card shadow mb-5">
        <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
            <h6 class="m-0 font-weight-bold text-info">Galeri</h6>
            <div class="dropdown no-arrow">
                <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                    <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
                </a>
            </div>
        </div>
        <div class="card-body">
            <div class="row">
                {% for gallery in galleries %}
                    <div class="col-md-3 mb-3">
                        <div class="bg-white rounded shadow-sm h-100">
                            {% if gallery.foto != '' %}
                                <img src="{{ gallery.foto.url }}" alt="" class="img-fluid card-img-top">
                                {% if gallery.deleted_at %}
                                    <div class="img-bagss">
                                        <div class="tag-bln">Diarsipkan</div>
                                    </div>
                                {% endif %}
                            {% else %}
                                <img class="img-fluid card-img-top" src="{% static 'profile/front/images/marapitrip.jpg' %}">
                            {% endif %}
                            <!-- {% if gallery.video %}
                                <div class="embed-responsive embed-responsive-4by3">
                                    <iframe class="embed-responsive-item" src="{{ gallery.video }}" allowfullscreen></iframe>
                                </div>
                                {% if gallery.deleted_at %}
                                    <div class="img-bagss">
                                        <div class="tag-bln">Diarsipkan</div>
                                    </div>
                                {% endif %}
                            {% endif %} -->
                            <div class="p-4">
                                <!-- <p class="mb-0">{{ gallery.title | truncatewords:8 }}</p> -->
                                <div class="d-flex align-items-center justify-content-center px-3 py-2 mt-4">
                                    <button href="#" class="btn btn-info btn-circle pass-data mr-3 mb-2" 
                                        data-tooltip="tooltip" data-placement="top" title="Detail"
                                        data-toggle="modal" data-target="#modal-center"
                                        data-title="{{ gallery.title }}"
                                        data-keterangan="{{ gallery.keterangan }}"
                                        data-jenis="{% if gallery.video %}Video{% else %}Foto{% endif %}"
                                        data-video="{{ gallery.video }}"
                                        data-foto="{% if gallery.foto %}{{gallery.foto.url}}{% endif %}"
                                        data-slug="{% url 'profile:admin_gallery_edit' slug=gallery.slug %}"
                                        data-created-at="{{ gallery.created_at }}">
                                        <i class="bi bi-info"></i>
                                    </button>
                                    <a class="btn btn-info btn-circle mr-3 mb-2" 
                                        href="{% url 'profile:admin_gallery_edit' slug=gallery.slug %}"
                                        data-toggle="tooltip" data-placement="top" title="Edit">
                                        <i class="bi bi-pencil"></i>
                                    </a>
                                    {% if gallery.deleted_at %}
                                        <button class="btn btn-success btn-circle mr-3 mb-2" 
                                            onclick="restore_(`{{ gallery.title }}`, '{{ gallery.slug }}', 'galeri', 'Galeri')"
                                            data-toggle="tooltip" data-placement="top" title="Tampilkan">
                                            <i class="bi bi-arrow-counterclockwise"></i>
                                        </button>
                                        <!-- {% if user.is_staff %}
                                            <button href="#" class="btn btn-danger btn-circle  mr-3 mb-2" 
                                                onclick="delete_('permanent_delete', `{{ gallery.title }}`, '{{ gallery.slug }}', 'galeri', 'Galeri')"
                                                data-toggle="tooltip" data-placement="top" title="Hapus Permanen">
                                                <i class="bi bi-trash"></i>
                                            </button>
                                        {% endif %} -->
                                    {% else %}
                                        <button href="#" class="btn btn-danger btn-circle mr-3 mb-2" 
                                            onclick="del('soft_delete', `{{ gallery.title }}`, '{{ gallery.slug }}', 'galeri', 'Galeri')"
                                            data-toggle="tooltip" data-placement="top" title="Arsipkan">
                                            <i class="bi bi-archive"></i>
                                        </button>
                                    {% endif %}
                                </div>
                            </div>
                        </div>
                    </div>
                {% endfor %}
            </div>
            
            <nav aria-label="Page navigation example">
                <ul class="pagination justify-content-center">
                    {% if galleries.has_other_pages %}
                        {% if galleries.has_previous %}
                            <li class="page-item">
                                <a class="page-link" href="?page={{ galleries.previous_page_number }}" tabindex="-1">Previous</a>
                            </li>
                        {% endif %}

                        {% for i in galleries.paginator.page_range %}
                            {% if galleries.number == i %}
                                <li class="page-item disabled">
                                    <a class="page-link" href="#" tabindex="-1">{{ i }}</a>
                                </li>
                            {% else %}
                                <li class="page-item"><a class="page-link" href="?page={{ i }}">{{ i }}</a></li>
                            {% endif %}
                        {% endfor %}

                        {% if galleries.has_next %}
                            <li class="page-item">
                                <a class="page-link" href="?page={{ galleries.next_page_number }}">Next</a>
                            </li>
                        {% endif %}
                    {% endif %}
                </ul>
            </nav>
        </div>
    </div>

    {% if request.user.is_staff and archives %}
        <div class="card shadow mb-5">
            <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
                <h6 class="m-0 font-weight-bold text-info">Arsip Galeri</h6>
                <div class="dropdown no-arrow">
                    <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
                    </a>
                </div>
            </div>
            <div class="card-body">
                <div class="row">
                    {% for archive in archives %}
                        <div class="col-md-3 mb-2">
                            <div class="bg-white rounded shadow-sm h-100">
                                {% if archive.foto != '' %}
                                    <img src="{{ archive.foto.url }}" alt="" class="img-fluid card-img-top">
                                    {% if archive.deleted_at %}
                                        <div class="img-bagss">
                                            <div class="tag-bln">Diarsipkan</div>
                                        </div>
                                    {% endif %}
                                {% else %}
                                    <img class="img-fluid card-img-top" src="{% static 'profile/front/images/marapitrip.jpg' %}">
                                {% endif %}
                                <!-- {% if archive.video %}
                                    <div class="embed-responsive embed-responsive-4by3">
                                        <iframe class="embed-responsive-item" src="{{ archive.video }}" allowfullscreen></iframe>
                                    </div>
                                    {% if archive.deleted_at %}
                                        <div class="img-bagss">
                                            <div class="tag-bln">Diarsipkan</div>
                                        </div>
                                    {% endif %}
                                {% endif %} -->
                                <div class="p-4">
                                    <!-- <p class="mb-0 text-sm">{{ archive.title | truncatewords:8 }}</p> -->
                                    <div class="d-flex align-items-center justify-content-center px-3 py-2 mt-4">
                                        <button href="#" class="btn btn-info btn-circle pass-data mr-3 mb-2" 
                                            data-tooltip="tooltip" data-placement="top" title="Detail"
                                            data-toggle="modal" data-target="#modal-center"
                                            data-title="{{ archive.title }}"
                                            data-keterangan="{{ archive.keterangan }}"
                                            data-jenis="{% if archive.video %}Video{% else %}Foto{% endif %}"
                                            data-video="{{ archive.video }}"
                                            data-foto="{% if archive.foto %}{{archive.foto.url}}{% endif %}"
                                            data-slug="{% url 'profile:admin_gallery_edit' slug=archive.slug %}"
                                            data-created-at="{{ archive.created_at }}">
                                            <i class="bi bi-info"></i>
                                        </button>
                                        <a class="btn btn-info btn-circle mr-3 mb-2" 
                                            href="{% url 'profile:admin_gallery_edit' slug=archive.slug %}"
                                            data-toggle="tooltip" data-placement="top" title="Edit">
                                            <i class="bi bi-pencil"></i>
                                        </a>
                                        {% if archive.deleted_at %}
                                            <button class="btn btn-success btn-circle mr-3 mb-2" 
                                                onclick="restore_(`{{ archive.title }}`, '{{ archive.slug }}', 'galeri', 'Galeri')"
                                                data-toggle="tooltip" data-placement="top" title="Tampilkan">
                                                <i class="bi bi-arrow-counterclockwise"></i>
                                            </button>
                                            <!-- {% if user.is_staff %}
                                                <button href="#" class="btn btn-danger btn-circle  mr-3 mb-2" 
                                                    onclick="delete_('permanent_delete', `{{ archive.title }}`, '{{ archive.slug }}', 'galeri', 'Galeri')"
                                                    data-toggle="tooltip" data-placement="top" title="Hapus Permanen">
                                                    <i class="bi bi-trash"></i>
                                                </button>
                                            {% endif %} -->
                                        {% else %}
                                            <button href="#" class="btn btn-danger btn-circle mr-3 mb-2" 
                                                onclick="delete_('soft_delete', `{{ archive.title }}`, '{{ archive.slug }}', 'galeri', 'Galeri')"
                                                data-toggle="tooltip" data-placement="top" title="Sembunyikan">
                                                <i class="bi bi-archive"></i>
                                            </button>
                                        {% endif %}
                                    </div>
                                </div>
                            </div>
                        </div>
                    {% endfor %}
                </div>
            </div>
        </div>
    {% endif %}
    
    <div class="modal fade" id="modal-center" tabindex="-1" role="dialog" aria-labelledby="modal-centerTitle" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered modal-lg" role="document">
            <div class="modal-content">
                <div class="modal-header">
                <h5 class="m-0 font-weight-bold text-info" id="exampleModalLongTitle">Detail Galeri</h5>
                <button type="button" class="close text-info" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
                </div>
                <div class="modal-body">
                    <div class="text-right mb-1">
                        <a href="" id="detail-slug" class="ml-2"> 
                            <button type="button" class="btn btn-info mt-2 mb-4"><i class="bi bi-pencil"></i> Edit</button>
                        </a>
                    </div>
                    <img src="" class="img-fluid w-100 d-non mb-1" alt="Responsive image" id="detail-foto">
                    <div class="embed-responsive embed-responsive-16by9 mb-1 d-none" id="detail-video-div">
                        <iframe class="embed-responsive-item" src="" allowfullscreen id="detail-video"></iframe>
                    </div>
                    <div class="form-group">
                        <label for="detail-title">Nama</label>
                        <input type="text" class="form-control" id="detail-title" disabled>
                    </div>
                    <div class="form-group">
                        <label for="detail-keterangan">Keterangan</label>
                        <textarea class="form-control" id="detail-keterangan" rows="3" disabled></textarea>
                    </div>
                    <div class="form-group">
                        <label for="detail-created-at">Tanggal</label>
                        <input type="text" class="form-control" id="detail-created-at" disabled>
                    </div>
                </div>
                <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                <!-- <button type="button" class="btn btn-info">Save changes</button> -->
                </div>
            </div>
        </div>
    </div>
{% endblock main %}

{% block footer %}
    {% include 'profile/layouts/admin/footer.html' %}
{% endblock footer %}

{% block scripts_bawah %}
    <script src="{% static 'profile/js/datatables/datatables.min.js' %}"></script>
    <script src="{% static 'profile/js/admin/admin-aksi.js' %}"></script>
    <script>
        $(document).ready( function () {
            $('[data-tooltip="tooltip"]').tooltip();
            $('#table-list').DataTable({
                responsive: true,
            });
            $('#table-archive').DataTable({
                responsive: true,
            });
        });
        $('.pass-data').click(function(){
            $('#detail-title').val($(this).attr('data-title'));
            $('#detail-keterangan').val($(this).attr('data-keterangan'));
            $('#detail-video').val($(this).attr('data-video'));
            $('#detail-foto').val($(this).attr('data-foto'));
            $('#detail-slug').attr('href', $(this).attr('data-slug'));
            $('#detail-created-at').val($(this).attr('data-created-at'));
            
            if($(this).attr('data-jenis') === 'Foto'){
                $('#detail-foto').attr('src', $(this).attr('data-foto'));
                $('#detail-foto').removeClass('d-none');
                $('#detail-video-div').addClass('d-none');
            }
            if($(this).attr('data-jenis') === 'Video'){
                $('#detail-video').attr('src', $(this).attr('data-video'));
                $('#detail-foto').addClass('d-none');
                $('#detail-video-div').removeClass('d-none');
            }
        });
        function del(action, nama,  slug, url, jenis){
            let pesan = action == 'soft_delete' ? "menyembunyikan" : "menghapus";
            let pesan2 = action == 'soft_delete' ? "sembunyikan" : "hapus";
            let confirmation = action == 'soft_delete' ? "Sembunyikan" : "Hapus";
            Swal.fire({
                title: `Apakah anda yakin ingin ${pesan} ${nama}?`,
                showCancelButton: true,
                confirmButtonText: confirmation,
                cancelButtonText: 'Batal',
                }).then((result) => {
                if (result.isConfirmed) {
                    $.ajax({
                        url: `/manage_panel/${url}/${action}/${slug}`,
                        data: {},
                        dataType: "html",
                        timeout: 10000,
                        beforeSend: function() {
                            Swal.fire({
                                title: 'Memproses.........',
                                allowEscapeKey: false,
                                allowOutsideClick: false,
                                showCancelButton: false,
                                showConfirmButton: false,
                            });
                            Swal.showLoading();
                        },
                        success: function(response){
                            Swal.fire(`${jenis} berhasil di${pesan2}!`, '', 'success');
                            setTimeout(function(){
                                window.location.href =  `/manage_panel/${url}`;
                            }, 2000); 
                        },
                        error: function (xhr, ajaxOptions, thrownError) {
                            Swal.fire(`${jenis} gagal di${pesan2}!`, '', 'error');
                        }
                    });
                    
                }
            });
        }
        function restore_(nama, slug, url, jenis){
            Swal.fire({
                title: `Apakah anda yakin ingin memulihkan ${nama}?`,
                showCancelButton: true,
                confirmButtonText: 'Pulihkan',
                cancelButtonText: 'Batal',
                }).then((result) => {
                if (result.isConfirmed) {
                    $.ajax({
                        url: `/manage_panel/${url}/restore/${slug}`,
                        data: {},
                        dataType: "html",
                        timeout: 10000,
                        beforeSend: function() {
                            Swal.fire({
                                title: 'Memproses.........',
                                allowEscapeKey: false,
                                allowOutsideClick: false,
                                showCancelButton: false,
                                showConfirmButton: false,
                                onOpen: () => {
                                    swal.showLoading();
                                }
                            });
                        },
                        success: function(response){
                            Swal.fire(`${jenis} berhasil dipulihkan!`, '', 'success');
                            setTimeout(function(){
                                window.location.href = `/manage_panel/${url}`;
                            }, 2000); 
                        },
                        error: function (xhr, ajaxOptions, thrownError) {
                            Swal.fire(`${jenis} gagal dipulihkan!`, '', 'error');
                        }
                    });
                    
                }
            });
        }
    </script>
{% endblock scripts_bawah %}